package com.njcn.csdevice.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csdevice.api.CsSoftInfoFeignClient;
import com.njcn.csdevice.pojo.po.CsSoftInfoPO;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author xy
 */
@Slf4j
@Component
public class CsSoftInfoClientFallbackFactory implements FallbackFactory<CsSoftInfoFeignClient> {
    @Override
    public CsSoftInfoFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new CsSoftInfoFeignClient() {
            @Override
            public HttpResult<CsSoftInfoPO> findSoftInfo(String id) {
                log.error("{}异常，降级处理，异常为：{}","获取装置软件信息",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<String> saveSoftInfo(CsSoftInfoPO po) {
                log.error("{}异常，降级处理，异常为：{}","保存软件程序",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<String> removeSoftInfo(String id) {
                log.error("{}异常，降级处理，异常为：{}","删除软件程序",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
